/*++++++++++++++
.IDENTIFICATION skserver.h
.LANGUAGE       C
.AUTHOR         Francois Ochsenbein [CDS]
.ENVIRONMENT    
.KEYWORDS       
.VERSION  1.0   12-Nov-1992
.VERSION  2.0   10-May-1993: Server part only
.VERSION  3.0   04-Nov-2003: Introduce a limit via sk_maxbytes
.COMMENTS       Declarations of sk routines
---------------*/

#ifndef sks_DEF
#define sks_DEF	0	/* To avoid several inclusions */

#ifndef _PARAMS
#ifdef __STDC__
#define _PARAMS(A)      A       /* ANSI */
#else
#define _PARAMS(A)      ()      /* Traditional */
#endif
#endif

#include <stdio.h>	/* Required for FILE definition */
#include <sk.h>		/* Required for subsystems	*/

extern int sk_start   _PARAMS((char *service, char *mode));
extern int sk_astart  _PARAMS((char *service, char *mode, char *passwd_file));
extern int sk_listen  _PARAMS((int sock, int queue_slots));
extern int sk_accept  _PARAMS((int sock, int queue_slots));
extern int sk_ack     _PARAMS((int plug));

extern int sk_read    _PARAMS((int plug, char *buf, int len));
extern int sk_get     _PARAMS((int plug, char *buf, int len));
extern int sk_gets    _PARAMS((int plug, char *buf, int len));
extern int sk_getl    _PARAMS((int plug));
extern int sk_write   _PARAMS((int plug, char *buf, int len));
extern int sk_put     _PARAMS((int plug, char *buf));
extern int sk_puts    _PARAMS((int plug, char *buf));
extern int sk_putl    _PARAMS((int plug, int val));
extern int sk_close   _PARAMS((int plug));
extern int sk_iosave  _PARAMS((int plug, char *buf, int len));

extern int sk_log     _PARAMS((int lev, /*char *fmt,*/ ...));
extern void sk_perror  _PARAMS((char *message));
extern void *sk_setlog _PARAMS((FILE *logfile));
extern void *sk_iolog  _PARAMS((FILE *logfile));
extern int  (*sk_setauth _PARAMS((int (* routine)(char *caller, char *passwd))))();
extern char *sk_caller _PARAMS((int plug));
extern int sk_umatch   _PARAMS((char *a/*remoteAtInternet:User*/, char *template));
extern int sk_passwd   _PARAMS((char *new_password, int plug));
extern void sk_urgent  _PARAMS((int plug));

extern int sk_errsend  _PARAMS((int plug, char *message));
extern int sk_perrsend _PARAMS((int plug, char *message)); /* perror msgs */

extern int sk_fromclient _PARAMS((int plug, int fh));
extern int sk_toclient _PARAMS((int plug, int fh));
extern int sk_maxbytes _PARAMS((int maxbytes));

extern int sk_servlog _PARAMS((int opt));	/* debugging log */

#endif	/* sks_DEF */
